import pandas as pd
from .utility import RISK_STYLES, INDUSTRY_STYLES


def single_style(portfolio, risk_exposure, risk_returns, specific_returns):
    risk_combined = pd.merge(portfolio[["security_code", "weight"]], risk_exposure, on=["security_code"])
    risk_combined[RISK_STYLES + INDUSTRY_STYLES] \
        = (risk_combined[RISK_STYLES + INDUSTRY_STYLES].values.T * risk_combined["weight"].values).T
    portfolio_risk_style_exposure = risk_combined[RISK_STYLES].sum()

    portfolio_exposure = risk_combined[RISK_STYLES + INDUSTRY_STYLES].sum()
    risk_attributed_rtn = risk_returns[RISK_STYLES + INDUSTRY_STYLES] * portfolio_exposure
    risk_combined = pd.merge(risk_combined, specific_returns[["security_code", "spret"]], on=["security_code"])
    spec_attributed_rtn = risk_combined["weight"] @ risk_combined["spret"] / 100.0
    risk_attributed_rtn["SPECIFIC"] = spec_attributed_rtn
    attributed_rtn = risk_attributed_rtn.copy()

    return portfolio_risk_style_exposure, attributed_rtn
